-------------------------------------------------------
-- led 16bit select inv
-- 2006/9/10
-------------------------------------------------------
library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_unsigned.all;

entity led16bitselinv is
	port(
		a		:in std_logic;
		b		:in std_logic;
		c		:in std_logic;
		d		:in std_logic;
		led_0	:out std_logic;
		led_1	:out std_logic;
		led_2	:out std_logic;
		led_3	:out std_logic;
		led_4	:out std_logic;
		led_5	:out std_logic;
		led_6	:out std_logic;
		led_7	:out std_logic;
		led_8	:out std_logic;
		led_9	:out std_logic;
		led_10	:out std_logic;
		led_11	:out std_logic;
		led_12	:out std_logic;
		led_13	:out std_logic;
		led_14	:out std_logic;
		led_15	:out std_logic
		);
end led16bitselinv;

architecture rtl of led16bitselinv is
	signal input_table	:std_logic_vector(3 downto 0);
	signal output_table	:std_logic_vector(15 downto 0);
	
begin

	input_table <=  d & c & b & a;

	with input_table select
		output_table <= "1111111111111110" when "0000",
						"1111111111111101" when "0001",
						"1111111111111011" when "0010",
						"1111111111110111" when "0011",
						"1111111111101111" when "0100",
						"1111111111011111" when "0101",
						"1111111110111111" when "0110",
						"1111111101111111" when "0111",
						"1111111011111111" when "1000",
						"1111110111111111" when "1001",
						"1111101111111111" when "1010",
						"1111011111111111" when "1011",
						"1110111111111111" when "1100",
						"1101111111111111" when "1101",
						"1011111111111111" when "1110",
						"0111111111111111" when "1111",
						"1111111111111111" when others;
						
	led_0 <= output_table(0);
	led_1 <= output_table(1);
	led_2 <= output_table(2);
	led_3 <= output_table(3);
	led_4 <= output_table(4);
	led_5 <= output_table(5);
	led_6 <= output_table(6);
	led_7 <= output_table(7);
	led_8 <= output_table(8);
	led_9 <= output_table(9);
	led_10 <= output_table(10);
	led_11 <= output_table(11);
	led_12 <= output_table(12);
	led_13 <= output_table(13);
	led_14 <= output_table(14);
	led_15 <= output_table(15);

end rtl;	
		